/*
 *
 *	Class(ses):	Compression
 *	Revision:	$Id:$
 *	Author:	 Steffen Schulze
 *
 *	Description:	The merged version of the Compression Rx and Tx paths of the pps
 *			
 *	Note:		
 *			
 *
 *	(c) Steffen Schulze, BTU Cottbus 2005
 */

#include "copra/pps/Compression.h"
#include "copra/pps/Packet.h"


namespace copra {


NetBuffer* Compression::createNetBuffer(BYTE* inputBuffer, UINTMAX inputBufferSize)
{
	#ifdef COMPRESS_DESIGNHAZARD
	NetBuffer* outputStack = new (this->pool) Packet;
	#else
	NetBuffer* outputStack = new Packet;
	#endif
			
	#ifdef COMPRESS_DEBUG
	assert(outputStack);
	#endif
	
	outputStack->reset();
	outputStack->upRef();
	outputStack->alloc(inputBufferSize);
	
	memcpy(outputStack->tos(), inputBuffer, inputBufferSize);
	
	return outputStack;
}

void Compression::appendStack(Stack* dest, Stack* src)
{
	assert(src->used());

	dest->alloc(src->used());
	memcpy(dest->tos(), src->tos(), src->used());
	
	dest->push((BYTE)(src->used()));
}

} //namespace
