#ifndef RLECODEC_H
#define RLECODEC_H

#include "../CompressorCodec.h"


/**
 * Run Length Encoding Codec Implementation
 *
 * Decodierung und Encodierung ueber durch Lauflaengenkodierung.
 * Dies ist die einfachste Variante. Kodierungen werden ueber ein seperates
 * Escapezeichen eingefuehrt.
 */
class RleCodec : public CompressorCodec
{
	public:
		/**
		 * Constructor
		 *
		 * Nichts Aufregendes...
		 */
		RleCodec()
		{
#ifdef TEXTOUTPUT
			textOutputMode = 1;
#endif
		}

		/**
		* Encode-Methode
		*
		* Implementiert die virtuelle Encode-Methode der Klasse CompressionCodec
		*/
		virtual	UINTMAX encode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize);
		
		/**
		* Decode-Methode
		*
		* Implementiert die virtuelle Decode-Methode der Klasse CompressionCodec
		*/
		virtual	UINTMAX decode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize);
	
	protected:
		/**
		 * Dies ist das Escapezeichen mit dem Kodierungen angefuehrt werden.
		 *
		 * Sollte ansich frei aenderbar sein
		 */
		enum escapechar_t {ESCAPECHAR = 123};
		
#ifdef TEXTOUTPUT
		int textOutputMode;
#endif
};

#endif
