#include "compress/rle2/Rle2Codec.h"


UINTMAX	Rle2Codec::encode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART encodeRLE2(%d)\n",inputBufferSize);
	}
	#endif

	BYTE preChar;
	BYTE currChar = 0;
	UINT16 count = 1;

	preChar = inputBuffer[0];
	UINTMAX outputBufferPos = 0;
	
	//fuer den ganzen inputPuffer
	for(UINTMAX inputBufferPos = 1; inputBufferPos <= inputBufferSize; inputBufferPos++)
	{
		//kopiere inputPufferzeichen in Cachevariable
		if(inputBufferPos < inputBufferSize)
		{
			currChar = inputBuffer[inputBufferPos];
		}

		if
		(
			(preChar == currChar)				// aktueller Charakter gleich dem vorhergehenden Charakter
			&&									// AND
			(count < MAXCHARCOUNTS)				// groesse der Reihe noch nicht Maximum
			&&									// AND
			(inputBufferPos != inputBufferSize)	// aktuelle Postition noch nicht inputPufferende
		)
		{
			count++;				// erhoehe zeichencounter um 1
		}
		else
		{
			///////////////////////////////////
			// flush informations to outputbuffer
			if
			(
				(count > 2)
				||
				(preChar > ESCAPECHAR)
			)
			{
			
				#ifdef TEXTDEBUG
				fprintf(stderr, "rle(%d,%d) ",count ,preChar);
				#endif
				////////////////
				//output as rle
				outputBuffer[outputBufferPos] = ESCAPECHAR + count;
				outputBufferPos++;			
				outputBuffer[outputBufferPos] = preChar;
				outputBufferPos++;			
			}
			else
			{
				if( preChar == ESCAPECHAR)
				{
					#ifdef TEXTDEBUG
					fprintf(stderr, "esc() ");
					#endif
					////////////////
					//output esc
					outputBuffer[outputBufferPos] = ESCAPECHAR + count;
					outputBufferPos++;
					outputBuffer[outputBufferPos] = preChar;
					outputBufferPos++;
				}
				else
				{
					////////////////
					//output pure
					for(BYTE i = 0; i < count; i++)
					{
						#ifdef TEXTDEBUG
						fprintf(stderr, "pure(%d) ",preChar);
						#endif
						outputBuffer[outputBufferPos] = preChar;
						outputBufferPos++;			
					}
				}
			}
			count = 1;						//deinit counter
			preChar = currChar;				//change preChar
		}	
    }

	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH encodeRLE2(%d)\n",outputBufferPos);
	}
	#endif

	return outputBufferPos;
}




UINTMAX Rle2Codec::decode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART decodeRLE2(%d)\n",inputBufferSize);
	}
	#endif
	
	BYTE currChar;
	UINTMAX outputBufferPos = 0;
	for(UINTMAX inputBufferPos	= 0;inputBufferPos < inputBufferSize; inputBufferPos++)
	{
		currChar = inputBuffer[inputBufferPos];
		
		if(currChar > ESCAPECHAR)
		{
			UINT16 count = currChar - ESCAPECHAR;
			inputBufferPos++;
			currChar = inputBuffer[inputBufferPos];
		
			#ifdef TEXTDEBUG
			fprintf(stderr, "rle(%d,%d) ",count,currChar);
			#endif
		
			for(UINT16 i = 0; i < count; i++)
			{
				outputBuffer[outputBufferPos] = currChar;
				outputBufferPos++;
			}
		}
		else
		{
			#ifdef TEXTDEBUG
			fprintf(stderr, "pure(%d) ",currChar);
			#endif
			outputBuffer[outputBufferPos] = currChar;
			outputBufferPos++;
		}
		
		MEMORYCHECK((outputBufferPos + 10) > outputBufferSize)

	}
	
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH decodeRLE2(%d)\n",outputBufferPos);
	}
	#endif
	
	return outputBufferPos;
}

